﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.moveButton.Click += moveButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 이동 버튼 클릭시 처리하기 - moveButton_Click(sender, e)

        /// <summary>
        /// 이동 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void moveButton_Click(object sender, EventArgs e)
        {
            const int MOVE_STEP = 10;

            Bitmap bitmap = new Bitmap(Image.FromFile("IMAGE\\sample.png"));

            Rectangle targetRectangle = new Rectangle(0, 0, bitmap.Width, bitmap.Height);

            Bitmap desktopBitmap = WIN32Helper.CaptureScreen();
            Bitmap bufferBitmap  = new Bitmap(targetRectangle.Width + MOVE_STEP, targetRectangle.Height + MOVE_STEP);

            IntPtr desktopDCHandle = WIN32Helper.GetDC(IntPtr.Zero);

            Graphics desktopGraphics = Graphics.FromHdc(desktopDCHandle);
            Graphics bufferGraphics  = Graphics.FromImage(bufferBitmap);

            Point targetPoint = new Point(500, 300);

            for(int i = 0, j = 0; i < 100; i += MOVE_STEP, j += MOVE_STEP)
            {
                bufferGraphics.DrawImage
                (
                    desktopBitmap,
                    0,
                    0,
                    new Rectangle
                    (
                        targetPoint.X + i,
                        targetPoint.Y + j,
                        targetRectangle.Width  + MOVE_STEP,
                        targetRectangle.Height + MOVE_STEP
                    ),
                    GraphicsUnit.Pixel
                );

                bufferGraphics.DrawImage
                (
                    bitmap,
                    MOVE_STEP,
                    MOVE_STEP,
                    targetRectangle,
                    GraphicsUnit.Pixel
                );

                desktopGraphics.DrawImage(bufferBitmap, targetPoint.X + i, targetPoint.Y + j);
            }

            for(int i = 100, j = 100; i > 0; i -= MOVE_STEP, j -= MOVE_STEP)
            {
                bufferGraphics.DrawImage
                (
                    desktopBitmap,
                    0,
                    0,
                    new Rectangle
                    (
                        targetPoint.X + i,
                        targetPoint.Y + j,
                        targetRectangle.Width  + MOVE_STEP,
                        targetRectangle.Height + MOVE_STEP
                    ),
                    GraphicsUnit.Pixel
                );

                bufferGraphics.DrawImage(bitmap, 0, 0, targetRectangle, GraphicsUnit.Pixel);

                desktopGraphics.DrawImage(bufferBitmap, targetPoint.X + i, targetPoint.Y + j);
            }

            bufferGraphics.Dispose();
            desktopGraphics.Dispose();

            WIN32Helper.ReleaseDC(IntPtr.Zero, desktopDCHandle);
        }

        #endregion
    }
}